package arzumify.polyenergy.impl;

import java.util.ArrayList;

// TODO: This seems very inefficient. Measure performance and then try improving this? This is O(n * m) which is very bad!

public class CoordinateMatchMaker {
    private static final ArrayList<ProviderDetails> providers = new ArrayList<>();
    private static final ArrayList<ReceiverDetails> receivers = new ArrayList<>();

    public static void update() {
        for (ReceiverDetails receiver : receivers) {
            for (ProviderDetails provider : providers) {
                if (provider.isInRange(receiver.pointsOfPresence())) {
                    provider.provider().exists(receiver.receiver(), provider.pointsOfPresence());
                }
            }
        }
    }

    public static void addProvider(ProviderDetails provider) {
        providers.add(provider);
        update();
    }

    public static void addReceiver(ReceiverDetails receiver) {
        receivers.add(receiver);
        update();
    }
}

